<?php
error_reporting( E_ALL ^ E_NOTICE );

// Disabling magic quotes at runtime from php.net
if( get_magic_quotes_gpc() )
{
    function stripslashes_deep($value)
    {
        $value = is_array($value) ?
                    array_map('stripslashes_deep', $value) :
                    stripslashes($value);
        return $value;
    }
    $_POST = array_map('stripslashes_deep', $_POST);
    $_GET = array_map('stripslashes_deep', $_GET);
    $_COOKIE = array_map('stripslashes_deep', $_COOKIE);
    $_REQUEST = array_map('stripslashes_deep', $_REQUEST);
}










// init - start

$HTMLParser_CommonCSS = Array(
'width','height','font','color','font-family','font-size','font-style','font-weight','letter-spacing',
'text-decoration','font-variant','text-indent','text-align','text-transform',
'background-color','background-image','background-repeat','background-position','background',
'first-line','first-letter',
'list-style-image','list-style-type','list-style-position','list-style',
'float','clear');

$HTMLParser_CommonAttr = Array( 'TITLE', 'LANG', 'DIR', 'STYLE' );

$HTMLParser_AllowTagsAry = Array();
$HTMLParser_AllowTagsAry['A'] = new HTMLParser_Tags_Class( 'A', '', array_merge($HTMLParser_CommonAttr,Array('HREF','CHARSET')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['B'] = new HTMLParser_Tags_Class( 'B', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['BDO'] = new HTMLParser_Tags_Class( 'BDO', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['BIG'] = new HTMLParser_Tags_Class( 'BIG', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['BR'] = new HTMLParser_Tags_Class( 'BR', 'f', array_merge($HTMLParser_CommonAttr,Array('CLEAR')) );
$HTMLParser_AllowTagsAry['CITE'] = new HTMLParser_Tags_Class( 'CITE', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['CODE'] = new HTMLParser_Tags_Class( 'CODE', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['DFN'] = new HTMLParser_Tags_Class( 'DFN', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['EM'] = new HTMLParser_Tags_Class( 'EM', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['FONT'] = new HTMLParser_Tags_Class( 'FONT', '', array_merge($HTMLParser_CommonAttr,Array('SIZE','COLOR','FACE')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['I'] = new HTMLParser_Tags_Class( 'I', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['IMG'] = new HTMLParser_Tags_Class( 'IMG', 'f', array_merge($HTMLParser_CommonAttr,Array('SRC','ALT','WIDTH','HEIGHT')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['KBD'] = new HTMLParser_Tags_Class( 'KBD', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['Q'] = new HTMLParser_Tags_Class( 'Q', '', array_merge($HTMLParser_CommonAttr,Array('CITE')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['S'] = new HTMLParser_Tags_Class( 'S', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['SAMP'] = new HTMLParser_Tags_Class( 'SAMP', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['SMALL'] = new HTMLParser_Tags_Class( 'SMALL', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['SPAN'] = new HTMLParser_Tags_Class( 'SPAN', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['STRONG'] = new HTMLParser_Tags_Class( 'STRONG', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['STRIKE'] = new HTMLParser_Tags_Class( 'STRIKE', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['SUB'] = new HTMLParser_Tags_Class( 'SUB', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['SUP'] = new HTMLParser_Tags_Class( 'SUP', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['TEXTAREA'] = new HTMLParser_Tags_Class( 'TEXTAREA', '', array_merge($HTMLParser_CommonAttr,Array('DISABLED','READONLY')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['TT'] = new HTMLParser_Tags_Class( 'TT', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['U'] = new HTMLParser_Tags_Class( 'U', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['VAR'] = new HTMLParser_Tags_Class( 'VAR', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );

$HTMLParser_AllowTagsAry['ADDRESS'] = new HTMLParser_Tags_Class( 'ADDRESS', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['CENTER'] = new HTMLParser_Tags_Class( 'CENTER', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['DD'] = new HTMLParser_Tags_Class( 'DD', 'o', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['DIR'] = new HTMLParser_Tags_Class( 'DIR', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['DIV'] = new HTMLParser_Tags_Class( 'DIV', '', array_merge($HTMLParser_CommonAttr,Array('ALIGN')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['DL'] = new HTMLParser_Tags_Class( 'DL', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['H1'] = new HTMLParser_Tags_Class( 'H1', '', array_merge($HTMLParser_CommonAttr,Array('ALIGN')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['H2'] = new HTMLParser_Tags_Class( 'H2', '', array_merge($HTMLParser_CommonAttr,Array('ALIGN')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['H3'] = new HTMLParser_Tags_Class( 'H3', '', array_merge($HTMLParser_CommonAttr,Array('ALIGN')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['H4'] = new HTMLParser_Tags_Class( 'H4', '', array_merge($HTMLParser_CommonAttr,Array('ALIGN')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['H5'] = new HTMLParser_Tags_Class( 'H5', '', array_merge($HTMLParser_CommonAttr,Array('ALIGN')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['H6'] = new HTMLParser_Tags_Class( 'H6', '', array_merge($HTMLParser_CommonAttr,Array('ALIGN')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['HR'] = new HTMLParser_Tags_Class( 'HR', 'f', array_merge($HTMLParser_CommonAttr,Array('ALIGN','NOSHADE')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['MARQUEE'] = new HTMLParser_Tags_Class( 'MARQUEE', '', array_merge($HTMLParser_CommonAttr,Array('BGCOLOR','DIRECTION','LOOP','SCROLLAMOUNT','SCROLLDELAY')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['MENU'] = new HTMLParser_Tags_Class( 'MENU', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['OL'] = new HTMLParser_Tags_Class( 'OL', '', array_merge($HTMLParser_CommonAttr,Array('TYPE','START')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['P'] = new HTMLParser_Tags_Class( 'P', 'o', array_merge($HTMLParser_CommonAttr,Array('ALIGN')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['PRE'] = new HTMLParser_Tags_Class( 'PRE', '', $HTMLParser_CommonAttr, $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['UL'] = new HTMLParser_Tags_Class( 'UL', '', array_merge($HTMLParser_CommonAttr,Array('TYPE')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['LI'] = new HTMLParser_Tags_Class( 'LI', 'o', array_merge($HTMLParser_CommonAttr,Array('TYPE','VALUE')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['DEL'] = new HTMLParser_Tags_Class( 'DEL', '', array_merge($HTMLParser_CommonAttr,Array('CITE','DATETIME')), $HTMLParser_CommonCSS );
$HTMLParser_AllowTagsAry['INS'] = new HTMLParser_Tags_Class( 'INS', '', array_merge($HTMLParser_CommonAttr,Array('CITE','DATETIME')), $HTMLParser_CommonCSS );

// init - end





// fixed init - start

$HTMLParser_TagsForREGAry = Array();
$HTMLParser_SingleTagAry  = Array();
$HTMLParser_DoubleTagsAry = Array();
while( $obj = current( $HTMLParser_AllowTagsAry ) )
{
	$HTMLParser_TagsForREGAry[] = $obj->nodeName;
	if( $obj->EndTag == 'f' )
		$HTMLParser_SingleTagAry[] = $obj->nodeName;
	else
		$HTMLParser_DoubleTagsAry[] = $obj->nodeName;

	next( $HTMLParser_AllowTagsAry );
}
$HTMLTagsForREG = implode( '|', $HTMLParser_TagsForREGAry );

// fixed init - end









/*
All Html Tags can be an object.
This class is for init only.
Like: <a></a>, <br>, <hr>
*/
Class HTMLParser_Tags_Class
{                     // eg: <a href='abc.htm' style='width:20'>
	public $nodeName; // nodeName is a.
	public $EndTag;   // EndTag like <a> for </a>, three states: ''->has end tag, 'o'->optional, 'f'->false, has no end tag.
	public $Attr;     // href is one attribute in this array.
	public $CSS;      // the element in style attribute.

	public function __construct( $nodeName, $EndTagState, $Attr=Array(), $CSS=Array() )
	{
		$this->nodeName = $nodeName;
		$this->EndTag   = $EndTagState;
		$this->Attr     = $Attr;
		$this->CSS      = $CSS;
	}
}

/*
The root of the Parsing Tree
*/
Class HTMLParser_Root_Class
{
	public $nodeName   = 'ROOT';
	public $Depth      = 0;
	public $childNodes = Array();
}

/*
The non-text object in the Parsing Tree
Like: <a></a>, <br>, <hr>
*/
Class HTMLParser_Other_Class
{
	public $Index;
	public $nodeName;
	public $Depth;

	public $AttrAry    = Array();
	public $childNodes = Array();

	public $Parent     = NULL;
	public $Previous   = NULL;
	public $Next       = NULL;
	public $Match      = false;
}

/*
The text object in the Parsing Tree
Like: the 'abc testing' words in <br>abc testing<br>
*/
Class HTMLParser_Text_Class
{
	public $Index;
	public $nodeName;
	public $Depth;
	public $nodeValue;

	public $Parent   = NULL;
	public $Previous = NULL;
	public $Next     = NULL;
}





/*
The main program
*/
Class HTMLParser_Class
{
	/*
	Written by David NG @ http://david.co
	Copyright(c) 1998-2007 david.co all rights reserved

	Start:   2004-08-31 20:16
	Finish:  2004-09-05 23:48
	Last Modify: 2004-11-14 13:19
	*/
	public $DOM;                          // It stores the object references. Parsing Tree, it has many nodes, each node may have many child node, and so on.
	public $DocumentAll       = Array();  // It stores the object references. array(div, text(hello world), hr, text(test1 ), span, text(test2), text(test3) )  for  <div>hello world<hr>test1 <span>test2</span>test3</div>

	private $ContainerTreeAry = Array();  // It stores the object references. array(root, div, span)  for  <div>hello world<hr>test1 <span>test2</span>test3</div>
	private $HTMLSourceCode;              // the html code you want to parse.





	public function __construct( $SourceCode='' )
	{
		global $HTMLTagsForREG;
		global $HTMLParser_SingleTagAry;
		global $HTMLParser_DoubleTagsAry;

		$SourceCode = preg_replace( '/<script[^<]*?>.*?<\/script[^<]*?>/ism' ,'' , $SourceCode );
		$SourceCode = preg_replace( '/<\!--.*?-->/ism'                       ,'' , $SourceCode );
		$SourceCode = preg_replace( '/&/'  , '&amp;' , $SourceCode );
		//$SourceCode = preg_replace( '/\[/' , '&#91;' , $SourceCode );
		//$SourceCode = preg_replace( '/]/'  , '&#93;' , $SourceCode );

		$this->HTMLSourceCode = $SourceCode;
		$this->DOM            = new HTMLParser_Root_Class();
		$RegMatchs            = Array();
		/*
			$RegMatchs[1] : value
			$RegMatchs[2] : begin or end tags 
			$RegMatchs[4] : attribute
		*/
		preg_match_all('/(.*?)<(\/?('. $HTMLTagsForREG .'))(\s.*?|)>/ism', $this->HTMLSourceCode, $RegMatchs, PREG_OFFSET_CAPTURE );





		$nodeValue     = NULL;
		$nodeName      = NULL;
		$tagName       = NULL;

		$Depth         = 1;
		$DA_Index      = 0;
		$REGAry_Index  = 0;
		$this->ContainerTreeAry[] = 'root';


		$TagsAry       = &$RegMatchs[2];
		$REGAryLen     = count($TagsAry);
		$AttrAry       = &$RegMatchs[4];
		$ValuesAry     = &$RegMatchs[1];

		$ValuesAry[$REGAryLen]    = Array();
		$ValuesAry[$REGAryLen][0] = strip_tags( substr( $this->HTMLSourceCode, $RegMatchs[0][$REGAryLen-1][1] + strlen($RegMatchs[0][$REGAryLen-1][0]) ) );

		$NodeValue     = strip_tags( $ValuesAry[$REGAry_Index][0] );
		if( $NodeValue != '' )
			$this->CreateTextElement( $NodeValue, $DA_Index++, $Depth );
		array_shift( $ValuesAry );





		while( true )
		{
			$nodeName  = strtoupper( $TagsAry[$REGAry_Index][0] );
			$nodeValue = strip_tags( $ValuesAry[$REGAry_Index][0] );

			if( in_array( $nodeName, $HTMLParser_DoubleTagsAry ) )
			{
				$this->CreateHTMLElement( $nodeName, $DA_Index++, $Depth++, false, $AttrAry[$REGAry_Index][0] );
				if( $nodeValue != '' )
					$this->CreateTextElement( $nodeValue, $DA_Index++, $Depth );
			}
			elseif( in_array( $nodeName, $HTMLParser_SingleTagAry ) )
			{
				$this->CreateHTMLElement( $nodeName, $DA_Index++, $Depth, true, $AttrAry[$REGAry_Index][0] );
				if( $nodeValue != '' )
					$this->CreateTextElement( $nodeValue, $DA_Index++, $Depth );
			}
			elseif( in_array( substr( $nodeName, 1 ), $HTMLParser_DoubleTagsAry ) )
			{
				$tagName = substr( $nodeName, 1 );
				for( $i=$DA_Index-1; $i>=0; $i-- )
				{
					if( $this->DocumentAll[$i]->nodeName==$tagName && $this->DocumentAll[$i]->Depth<$Depth && $this->DocumentAll[$i]->Match==false )
					{
						$this->SetMatch( $this->DocumentAll[$i] );
						$Depth = $this->DocumentAll[$i]->Depth;
						break;
					}
				}
				if( $nodeValue != '' )
					$this->CreateTextElement( $nodeValue, $DA_Index++, $Depth );
			}
			elseif( $nodeValue != '' )
			{
				$this->CreateTextElement( $nodeValue, $DA_Index++, $Depth );
			}


			if( ++$REGAry_Index >= $REGAryLen )
				break;
		}
	}





	private function CreateHTMLElement( $Name, $Index, $Depth, $Match=false, $AttrSoruceCode )
	{
		global                  $HTMLParser_AllowTagsAry;
		$TagObj               = $HTMLParser_AllowTagsAry[$Name];
		$NowElement           = &$this->DocumentAll[$Index];
		$NowElement           = new HTMLParser_Other_Class();
		$NowElement->nodeName = $Name;
		$NowElement->Depth    = $Depth;
		$NowElement->Index    = $Index;
		$NowElement->Match    = $Match;

		$RegMatchsAttr        = Array();
		/*
		$RegMatchsAttr[1] : attr name
		$RegMatchsAttr[4] : value  main value and if $RegMatchsAttr[5] isn't null, copy here
		$RegMatchsAttr[5] : value  ( copy to $RegMatchsAttr[4] if it isn't null )

		$RegMatchsCSS[1] : css name
		$RegMatchsCSS[3] : css value
		*/
		preg_match_all('/('. implode( '|', $TagObj->Attr ) .')\s*  (=\s*(\'|")(.*?)\3  |   =\s*([^\s]*)   |  \s*   )    (\s+|$) /ismx', $AttrSoruceCode, $RegMatchsAttr );


		$len   = count( $RegMatchsAttr[1] );
		for( $i=0; $i<$len; $i++ )
		{
			if( $RegMatchsAttr[5][$i] != '' )
				$RegMatchsAttr[4][$i] = $RegMatchsAttr[5][$i];

			$AttrName  = strtoupper( $RegMatchsAttr[1][$i] );
			$AttrValue = preg_replace( '/"/','\'', $RegMatchsAttr[4][$i] );

			if( $AttrValue != ''  )
			{
				if( $AttrName=='HREF' || $AttrName=='SRC' )
				{
					$AttrValue = preg_replace( '/^\s*(javascript|vbscript)\s*:?\s*/ism', '', $AttrValue );
					$NowElement->Attr[$AttrName] = $AttrName.'="'.$AttrValue.'"';
				}
				elseif( $AttrName == 'STYLE' )
				{
					$RegMatchsCSS = Array();
					preg_match_all('/('. implode( '|', $TagObj->CSS ) .')\s*:\s*(\'|)(.*?)\2\s*(;|$)/ism', $AttrValue, $RegMatchsCSS );
					$RegCSSLen = count($RegMatchsCSS[1]);
					for( $k=0; $k<$RegCSSLen; $k++ )
						$NowElement->CSS[$RegMatchsCSS[1][$k]] = $RegMatchsCSS[1][$k] .':'. preg_replace( '/\s*expression\s*\(.*?\)\s*(;|$)/ism', '', $RegMatchsCSS[3][$k] );

					$RegMatchsCSS = NULL;				
				}
				else
					$NowElement->Attr[$AttrName] = $AttrName.'="'.$AttrValue.'"';
			}
			else
				$NowElement->Attr[$AttrName] = $AttrName;

		}

		if( $TagObj->EndTag != 'f' )
			$this->ContainerTreeAry[$Depth] = &$NowElement;

		$this->AddNode( $NowElement );
	}





	private function CreateTextElement( $Value, $Index, $Depth )
	{
		$NowElement            = &$this->DocumentAll[$Index];
		$NowElement            = new HTMLParser_Text_Class();
		$NowElement->nodeName  = 'text';
		$NowElement->nodeValue = $Value;
		$NowElement->Depth     = $Depth;
		$NowElement->Index     = $Index;

		$this->AddNode( $NowElement );
	}





	private function AddNode( &$NowElement )
	{
		// Depth=0 is htmlRoot
		if( $NowElement->Depth >= 2 )
		{
			$ParentElement      = &$this->ContainerTreeAry[$NowElement->Depth-1];
			$NowElement->Parent = &$ParentElement;

			$len = count( $ParentElement->childNodes );
			if( $len >= 1 )
			{
				$PreElement              = &$ParentElement->childNodes[ $len-1 ];
				$PreElement->Next        = &$NowElement;
				$NowElement->Previous    = &$PreElement;
			}
			$ParentElement->childNodes[] = &$NowElement;
		}
		else
			$this->DOM->childNodes[]     = &$NowElement;
	}





	/*
	Two Tags has match in DOM node
	like <p>  match  </p>
	*/
	private function SetMatch( &$obj )
	{
		if( $obj->nodeName!='text' && $obj->Match==false )
		{
			$len = count( $obj->childNodes );
			for( $i=0; $i<$len; $i++ )
				$this->SetMatch( $obj->childNodes[$i] );
			$obj->Match = true;
		}
	}





	public function DOMToUBB( &$str ) // UBB? we have the DOM now, you can do whatever you want.
	{
		$len = count( $this->DOM->childNodes );
		for( $i=0; $i<$len; $i++ )
			$this->DumpFromObj( $this->DOM->childNodes[$i], $str );
	}





	public function DumpFromObj( &$obj, &$str )
	{
		global $HTMLParser_DoubleTagsAry;
		if( $obj->nodeName == 'text' )
			$str .= $obj->nodeValue;
		else
		{
			if( count( $obj->Attr ) )
				$Attr = ' '.implode( ' ', $obj->Attr );
			else
				$Attr = '';

			if( count( $obj->CSS ) )
				$CSS = ' STYLE="'.implode( ';', $obj->CSS ).'"';
			else
				$CSS = '';

			$str .= '<'. $obj->nodeName . $Attr . $CSS .'>';

			$len = count( $obj->childNodes );
			for( $i=0; $i<$len; $i++ )
				$this->DumpFromObj( $obj->childNodes[$i], $str );
			if( in_array( $obj->nodeName, $HTMLParser_DoubleTagsAry ) )
				$str .= '</'. $obj->nodeName .'>';
		}
	}
}





?><META Http-Equiv="Content-Type"  Content="text/html; charset=utf-8">
<title>david.co - web application - php html parser (php5)</title>
Written by David NG @ <a href="http://david.co">http://david.co</a><BR>
Copyright(c) 1998-2004 david.co all rights reserved<BR><BR>

<a href="html_parser_src_php5.zip">download - html parser (php 5) - source code</a><BR>

<font color=blue><xmp><?php





$Content = $_POST['Content'];
if( isset( $Content ) )
{
	$DOM = new HTMLParser_Class( $Content );

	$Str = '';
	$DOM->DOMToUBB( $Str );
	echo $Str;
}





?></xmp></font>
<form method="post" >
<textarea name="Content" style="width:500;height:100"><a  disabled title=" hello
world"  style="width:200; he"ight:expression(200);background:red" 4534 CHARSET = en href="#" dir = 'rtl' disabled >gogo</a><p style='background: url("images/aardvark.gif"); background-repeat: repeat-y; ' title=good size=5 style='width:20;height:50;'>hi <b color="red">test<b>
how	<a href="javascript:http:david.co" border=1>are<font color=red>you</a>
	?</hello>
tell </p>me
<big>
	you <div>love<span> me</span>
</big>end</textarea><BR>
<input type="submit">
</form>